/* 
 * title : myjmap.c  -  show japan map and simple infomations.
 * begin : 2003/10/06
 * make  : gcc -o myjmap -I /usr/X11R6/include -L /usr/X11R6/lib myjmap.c
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <X11/Xlib.h>
#include  <X11/Xutil.h>

/* Ͽޤbitmapե */
#include  "myjmap.xbm"

/* եȻŬѹƲ */
#define ALPHA_FONT "-*-helvetica-medium-r-normal--14-*-*-*-*-*-*-*"
/*
#define KANJI_FONT "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
*/
#define KANJI_FONT "k14"

/* ǡե */
#ifdef   Linux
#define  INFO_FILE      "/usr/dict/myjmap.info"
#endif
#ifdef   FreeBSD
#define  INFO_FILE      "/usr/share/dict/myjmap.info"
#endif

/* Ƽ */
#define  STR_LEN        256    /* ʸĹ */
#define  DISTS          47     /* ƻܸο */
#define  WIN_WIDTH      640    /* ɥĹ */
#define  WIN_HEIGHT     480    /* ɥĹ */
#define  INFO_WIDTH     240    /* 󥦥ɥĹ */
#define  INFO_HEIGHT    140    /* 󥦥ɥĹ */
#define  BUTTON_WIDTH   5
#define  BUTTON_HEIGHT  5

/* ָפΥǡ¤ */
struct MAP_INFO {
  char  name[STR_LEN];  /* ̾       */
  char  city[STR_LEN];  /* ģ */
  char  area[STR_LEN];  /*        */
  char  popu[STR_LEN];  /* ͸       */
  char  flwr[STR_LEN];  /* β     */
  char  tree[STR_LEN];  /*      */
  int   x;              /* ɸxɸ  */
  int   y;              /* ɸyɸ  */
};

struct  MAP_INFO  map[DISTS];

Display  *disp;
Window   win, w_info, button[DISTS];
Pixmap   back;
GC       gc_a, gc_k;
XEvent   e;
XFontStruct  *f_a, *f_k;
XSetWindowAttributes  attr;


/* functions */

/* ʸؿ */
/* ХǵꣲХȤʸʸƬФ */
int getLtr(char *str)
{
  int c, d;
  c = *str;
  d = *(++str);
  if (c >= 0 && c <= 0x7f) return c;
  return c * 256 + d;
}

/* ʸؿ */
/* եȹ¤ΤȤΤϡȤΤȤޤ */
int  draw_string(Display  *d, Window  w, int  x, int  y, char  *p)
{
  int     c;
  char    eng[2];
  XChar2b knj[2];

  while (*p != '\0') {
    c = getLtr(p);
    if (c >= 0 && c <= 0x7f) {
    /* Хʸξ */
      eng[0] = c;
      XDrawString(d, w, gc_a, x, y, eng, 1);
      x += XTextWidth(f_a, eng, 1);
      p++;
    }
    else {
    /* Хʸξ */
      knj[0].byte1 = (c / 256) & 0x7f;
      knj[0].byte2 = (c % 256) & 0x7f;
      XDrawString16(d, w, gc_k, x, y, knj, 2);
      x += XTextWidth16(f_k, knj, 1);
      p+=2;
    }
  }
}

int  redraw_info(Display  *d, Window w, int i)
{
  int  xp = 10, yp = 5, dy = 17;
  XClearWindow(d, w);
  draw_string(d, w, 10, yp+=dy, map[i].name); 
  draw_string(d, w, 10, yp+=dy, map[i].city); 
  draw_string(d, w, 10, yp+=dy, map[i].area); 
  draw_string(d, w, 10, yp+=dy, map[i].popu); 
  draw_string(d, w, 10, yp+=dy, map[i].flwr); 
  draw_string(d, w, 10, yp+=dy, map[i].tree); 
}

int  draw_info(Display  *d, Window w, int i)
{
  XMapRaised(d, w);
  redraw_info(d, w, i);
}


int  main(int argc, char **argv[], char **envp)
{
  FILE  *fp;
  int   i = 0, pos = 0;
  char  *p, *file_name = INFO_FILE;

  if (getenv("MYJMAP_INFO") != '\0') file_name = getenv("MYJMAP_INFO");

  /*  read information data from file  */
  if ((fp = fopen(file_name, "r")) == NULL) {
    fprintf(stderr, "error : cannot open information file '%s''\n", file_name);
    exit(1);
  }

  while (feof(fp) == 0) {
    fscanf(fp, "%s",   map[i].name);
    fscanf(fp, "%d%d", &map[i].x, &map[i].y);
    fscanf(fp, "%s", map[i].city);
    fscanf(fp, "%s", map[i].area);
    fscanf(fp, "%s", map[i].popu);
    fscanf(fp, "%s", map[i].flwr);
    fscanf(fp, "%s", map[i].tree);
    i++;
  }

  fclose(fp);

  disp = XOpenDisplay(NULL);
  win  = XCreateSimpleWindow(disp, RootWindow(disp, 0),
           100, 100, WIN_WIDTH, WIN_HEIGHT,
           2, BlackPixel(disp, 0), WhitePixel(disp, 0));
  XSelectInput(disp, win, ButtonPressMask | ExposureMask);
  XMapWindow(disp, win);
  XStoreName(disp, win, "Myjmap ver 1.00");

  w_info  = XCreateSimpleWindow(disp, RootWindow(disp, 0),
           100, 100, INFO_WIDTH, INFO_HEIGHT,
           2, BlackPixel(disp, 0), WhitePixel(disp, 0));
  XSelectInput(disp, w_info, ExposureMask | ButtonPressMask);
  XStoreName(disp, w_info, "Info...");

  for (i = 0; i < DISTS; i++) {
    button[i] = XCreateSimpleWindow(disp, win,
                  map[i].x, map[i].y, BUTTON_WIDTH, BUTTON_HEIGHT, 1,
                  BlackPixel(disp, 0), WhitePixel(disp, 0)); 
    XSelectInput(disp, button[i], ButtonPressMask | EnterWindowMask);
    attr.override_redirect = True;
    XChangeWindowAttributes(disp, button[i], CWOverrideRedirect, &attr);
    XMapWindow(disp, button[i]);
  }

  /*  back ground pixmap drawing */
  back = XCreatePixmapFromBitmapData(disp, win, myjmap_bits, myjmap_width,
          myjmap_height, BlackPixel(disp, 0), WhitePixel(disp, 0),
          DefaultDepth(disp, 0));
  XSetWindowBackgroundPixmap(disp, win, back);

  gc_a = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  gc_k = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  f_a = XLoadQueryFont(disp, ALPHA_FONT);
  f_k = XLoadQueryFont(disp, KANJI_FONT);
  XSetFont(disp, gc_a, f_a->fid);
  XSetFont(disp, gc_k, f_k->fid);

  while (1) {
    XNextEvent(disp, &e);
    /*  exit if press button in main window  */
    if (e.xany.window == win && e.type == ButtonPress && e.xbutton.button == 3)
      break;
    /*  redraw background pixmap  */
    if (e.xany.window == win && e.type == Expose)
      XClearWindow(disp, win);
    /*  hide information window if button pressed in  */
    if (e.xany.window == w_info && e.type == ButtonPress)
      XUnmapWindow(disp, w_info);

    if (e.xany.window == w_info && e.type == Expose)
      redraw_info(disp, w_info, pos);

    for (i = 0; i < DISTS; i++)
      if (e.xany.window == button[i] && e.type == EnterNotify) {
        pos = i;
        draw_info(disp, w_info, pos);
      }

  }

  XCloseDisplay(disp);
  exit(0);
}
