/* 
 * title : xring.c  -  ֥󥰡 X version.
 * begin : 2005/09/22
 * make  : gcc xring.c -o xring -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>

/* ɥɽʸ */
#define  COL_MAX  21
#define  LIN_MAX  12

/* ʸ */
#define  LF  0x0a

#define  ON   1
#define  OFF  0

/* X ѿ */
Display *disp;
Window  win, btn;
Font    fnt;
GC      gc;
XEvent  evnt;
unsigned long black, white;

/* ԡ򼨤ǥ */
int lin = 0, col = 0;
/* ꡼ɽʸƤ */
int scr_code[COL_MAX][LIN_MAX];
/* ꡼ɽʸѰ̤Ͽ */
int attr_h[COL_MAX][LIN_MAX],attr_v[COL_MAX][LIN_MAX];

struct  itimerval new_time, old_time;
int  flg = 0;


/* ؿ */

/* EUC ʸ ʰץ桼ƥƥ */
/* ȥ꡼फ1ʸ */
int 
getLtr(FILE  *fp)
{
  int  c, d;

  /*  1Хʸξ  */
  if ((c = fgetc(fp)) < 128) return c;
  /*  2Хʸξ  */
  if ((d = fgetc(fp)) == EOF)
    return  EOF;
  return (c*256 + d);
}

/* 1ʸ */
int 
putLtr(int  ch)
{
  if (ch < 256)
    putchar(ch);
  else
    printf("%c%c", ch/256, ch%256);
}


/*  */
int 
irand(int lim)
{
  return (int) ((float) rand() / RAND_MAX * lim);
}

/* ʸ */
/* (ޥåʥС¿) */
void
drawLetter(int col, int lin, char *str)
{
  XDrawString16(disp, win, gc, col*30+5+3+attr_h[col][lin], lin*35+42-3+attr_v[col][lin], (XChar2b *) str, 2);
}


/* ʸư */
void
move_char()
{
  char  str[3];
  int code;

  /* ʸΰ֤˷ */
  col = irand(COL_MAX);
  lin = irand(LIN_MAX);
  /* ʸΥɤ */
  str[0] = (scr_code[col][lin] / 256) & 0x7f;
  str[1] = scr_code[col][lin] & 0x7f;

  /* ʸä */
  XSetForeground(disp, gc, white);
  drawLetter(col, lin, str);
  /* ʸѰ̤ᡢ */
  attr_h[col][lin] = irand(7) - 3;
  attr_v[col][lin] = irand(7) - 3;
  /* ֤ʸ */
  XSetForeground(disp, gc, black);
  drawLetter(col, lin, str);
  /* С׵եå夷Ƥ */
  XFlush(disp);
}


void
alarm_set(int mode)
{
  /* ǽԤĻ */
  new_time.it_interval.tv_sec  = 0;
  if (mode == ON)
    new_time.it_interval.tv_usec = 10000;
  else
    new_time.it_interval.tv_usec = 0;

    new_time.it_value.tv_sec     = 0;
  if (mode == ON)
    new_time.it_value.tv_usec    = 10000;
  else
    new_time.it_value.tv_usec    = 0;

    setitimer(ITIMER_REAL, &new_time, &old_time);
}

/* δؿ */
void
redraw()
{
  char  str[3];
  int i, j;

  /* κϥ顼ॷʥٻߤƤ */
  if (flg != 0)
    alarm_set(OFF);

  for (j = 0; j < LIN_MAX; j++)
    for (i = 0; i < COL_MAX; i++) {
      str[0] = (scr_code[i][j] / 256) & 0x7f;
      str[1] = scr_code[i][j] & 0x7f;
      XSetForeground(disp, gc, black);
      drawLetter(i, j, str);
    }

  /* 褬äΤǡ顼ॷʥƳ */
  if (flg != 0)
    alarm_set(ON);

}



int
main(int  argc, char  **argv)
{
  FILE  *fp;
  int  i, j, c;
  time_t  tim;

  if (argc <= 1) {
    fprintf(stderr, "usage : %s <EUC text file>\n", argv[0]);
    exit(1);
  }

  /* ν */
  time(&tim);
  srand(tim);

  /* EUCƥȥեɤ߹ */
  if ((fp = fopen(argv[1], "r")) == NULL) {
    fprintf(stderr, "error : cannot open '%s'\n", argv[1]);
    exit(1);
  }
  while ((c = getLtr(fp)) != EOF) {
    /* ԤʤС*/
    if (c == LF) {
      if (lin < LIN_MAX-1) {
        lin++;  col = 0;
      } else
        break;
    } else
    if (col >= COL_MAX) {
      if (lin < LIN_MAX-1) {
        lin++;  col = 0;
	scr_code[col][lin] = c;
	col++;
      } else
        break;
    } else {
      scr_code[col][lin] = c;
      col++;
    }
  }
  fclose(fp);

  /* Xν */
  disp = XOpenDisplay(NULL);
  /* Ƥ */
  black = BlackPixel(disp, 0);
  white = WhitePixel(disp, 0);

  /* ɥȡܥ˻Ȥ֥ɥߤ */
  win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 880, 640, 480, 2, black, white);
  btn = XCreateSimpleWindow(disp, win,
          10, 450, 80, 25, 1, black, white);
  /* ɥϪФȥܥ󲡲ΥȤ */
  XSelectInput(disp, win, ExposureMask | ButtonPressMask);
  XSelectInput(disp, btn, ExposureMask | ButtonPressMask);

  /* եȤɤ߹ǡꤹ */
  /* ʪ碌ʤΤǡեȤѤˤϳƼѥ᥿Ѥɬפ */
  gc = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  fnt = XLoadFont(disp, "kanji24");
  XSetFont(disp, gc, fnt);

  /* ɥޥ͡㡼˥ȥΤ */
  XStoreName(disp, win, "... ring");
  /* ɥȡ֥ܥפɽ */
  XMapWindow(disp, win);
  XMapSubwindows(disp, win);

  while (1) {
    XNextEvent(disp, &evnt);
    /* ɥϪФ顢 */
    if (evnt.type == Expose) {
      redraw();
    } else
    /* ܥ򲡤顢Ͽ */
    if (evnt.type == ButtonPress && evnt.xany.window == btn) {
      /* ܥؤե饰å */
      /* 0ʤС顼ॷʥꤷ */
      /* 1ʤСץλ */
      if (flg == 0) {
	/* ܥεǽؤե饰򥻥å */
	flg = 1;
	/* 顼ॷʥΥϥɥ */
	if (signal(SIGALRM, move_char) == SIG_ERR) {
	  perror("singal handling");
	  exit(1);
	}
	/* 顼 */
	alarm_set(ON);
      } else
	/* 롼פæλ */
        break;
    }
  }
  /* 顼ٻ */
  alarm_set(OFF);

  XCloseDisplay(disp);
  exit(0);

}
