/*
 * title : xvortex.c  -  X programming example
 * begin : 2003/05/08
 * make  : gcc xvortex.c -o xvortex -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 *  
 */

#include <X11/Xlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#define  WIN_WIDTH   550
#define  WIN_HEIGHT  550

#define  POINT_MAX  600
#define  RATE       0.9

/*  Q}`̍Wێz  */
XPoint pos[2][POINT_MAX];

int main(int argc, char *argv[])
{
  Display  *d;
  Window  win;
  GC  gc;
  Font  f;
  XEvent  e;
  int  i, dir = 0;
  double  th;

  fprintf(stderr, "*** %s info : Drawing vortex\n", argv[0]);
  fprintf(stderr, "push key    ... draw another direction of vortex\n");
  fprintf(stderr, "push button ... end of run\n");

/*  Q͗l̍WvZ  */
  for (i = 0; i < POINT_MAX; i++) {
    th = i*2*M_PI*10/POINT_MAX;
    pos[0][i].x = WIN_WIDTH/2 + WIN_WIDTH/2*RATE*i/POINT_MAX*cos(th);
    pos[1][i].x = WIN_WIDTH/2 - WIN_WIDTH/2*RATE*i/POINT_MAX*cos(th);
    pos[0][i].y = WIN_WIDTH/2 - WIN_WIDTH/2*RATE*i/POINT_MAX*sin(th);
    pos[1][i].y = WIN_WIDTH/2 - WIN_WIDTH/2*RATE*i/POINT_MAX*sin(th);
  }

  d = XOpenDisplay(NULL);
  win = XCreateSimpleWindow(d, DefaultRootWindow(d),
        100, 100, WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  gc = XCreateGC(d, win, 0, 0);
  XSetLineAttributes(d, gc, 10, LineSolid, CapRound, JoinMiter);
  XStoreName(d, win, "Xvortex");

/*  L[́AEBhE\IA}EX{^ߑ  */
  XSelectInput(d, win, KeyPressMask | ExposureMask | ButtonPressMask);
  XMapWindow(d, win);

/*  eCxgɑΉCE[v  */
  for (;;) {
    XNextEvent(d, &e);
    if (e.type == KeyPress) break;
    if (e.type == Expose) {
      XClearWindow(d, win);
      XDrawLines(d, win, gc, pos[dir], POINT_MAX, CoordModeOrigin);
    }
    if (e.type == ButtonPress) {
      dir = 1 - dir;
      XClearWindow(d, win);
      XDrawLines(d, win, gc, pos[dir], POINT_MAX, CoordModeOrigin);
    }
  }

  XCloseDisplay(d);
}
